
package de.ivu.elect.business.entschaedigung.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.entschaedigung.entity.Entschaedigung;

@RequestScoped
@Named(EntschaedigungConversationSelect.COMPONENT_NAME)
public class EntschaedigungConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "entschaedigungConversationSelect";

  @Inject
  protected transient EntschaedigungExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(EntschaedigungConversationStore.class)
  protected transient EntschaedigungConversationStore conversationStore;

  public EntschaedigungConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Entschaedigung getEntity() {
    return getEntityInternal();
  }

  private Entschaedigung getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Entschaedigung entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.entschaedigung.entity.EntschaedigungPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Entschaedigung entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.entschaedigung.entity.EntschaedigungPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.entschaedigung.entity.EntschaedigungPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Entschaedigung attach(Entschaedigung entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Entschaedigung attach( de.ivu.elect.business.entschaedigung.entity.EntschaedigungPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
